// Package gen provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package gen

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	"github.com/oapi-codegen/runtime"
)

// ServerInterface represents all server handlers.
type ServerInterface interface {

	// (GET /openapi.json)
	Openapi(ctx echo.Context) error

	// (GET /v1/healthz)
	Healthcheck(ctx echo.Context) error

	// (GET /v1/metrics)
	Metrics(ctx echo.Context) error

	// (GET /v1/tool/{toolname}/envvars)
	List(ctx echo.Context, toolname string) error

	// (POST /v1/tool/{toolname}/envvars)
	Create(ctx echo.Context, toolname string) error

	// (DELETE /v1/tool/{toolname}/envvars/{name})
	Delete(ctx echo.Context, toolname string, name EnvvarName) error

	// (GET /v1/tool/{toolname}/envvars/{name})
	Show(ctx echo.Context, toolname string, name EnvvarName) error

	// (GET /v1/tool/{toolname}/quotas)
	Quota(ctx echo.Context, toolname string) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// Openapi converts echo context to params.
func (w *ServerInterfaceWrapper) Openapi(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Openapi(ctx)
	return err
}

// Healthcheck converts echo context to params.
func (w *ServerInterfaceWrapper) Healthcheck(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Healthcheck(ctx)
	return err
}

// Metrics converts echo context to params.
func (w *ServerInterfaceWrapper) Metrics(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Metrics(ctx)
	return err
}

// List converts echo context to params.
func (w *ServerInterfaceWrapper) List(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.List(ctx, toolname)
	return err
}

// Create converts echo context to params.
func (w *ServerInterfaceWrapper) Create(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Create(ctx, toolname)
	return err
}

// Delete converts echo context to params.
func (w *ServerInterfaceWrapper) Delete(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	// ------------- Path parameter "name" -------------
	var name EnvvarName

	err = runtime.BindStyledParameterWithOptions("simple", "name", ctx.Param("name"), &name, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter name: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Delete(ctx, toolname, name)
	return err
}

// Show converts echo context to params.
func (w *ServerInterfaceWrapper) Show(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	// ------------- Path parameter "name" -------------
	var name EnvvarName

	err = runtime.BindStyledParameterWithOptions("simple", "name", ctx.Param("name"), &name, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter name: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Show(ctx, toolname, name)
	return err
}

// Quota converts echo context to params.
func (w *ServerInterfaceWrapper) Quota(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Quota(ctx, toolname)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/openapi.json", wrapper.Openapi)
	router.GET(baseURL+"/v1/healthz", wrapper.Healthcheck)
	router.GET(baseURL+"/v1/metrics", wrapper.Metrics)
	router.GET(baseURL+"/v1/tool/:toolname/envvars", wrapper.List)
	router.POST(baseURL+"/v1/tool/:toolname/envvars", wrapper.Create)
	router.DELETE(baseURL+"/v1/tool/:toolname/envvars/:name", wrapper.Delete)
	router.GET(baseURL+"/v1/tool/:toolname/envvars/:name", wrapper.Show)
	router.GET(baseURL+"/v1/tool/:toolname/quotas", wrapper.Quota)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xY34/bNhL+VwheHu4AWdJmc7ir39I2SIMkTbpJi7Ybt6DFscWsRHLJkb3uwv97MaTk",
	"X/Lau2k2KYK+GJZEznwz8/HjkNe8MLU1GjR6PrzmDrw12kN4mBg3VlKCpofCaASN9FdYW6lCoDI6e+9N",
	"+OyLEmpB/x44mPAh/1e2tpzFrz47a82/BO/FFDxfLpcJl+ALpyzZ40P+i2mYcMBW3tnEmZpZcBPjaqWn",
	"DEvlmSjC+GXClUZwWlQDcM64T4r1sWaddxa8s1JYCxokAdMGBxPTaPlJMb0tgVUCwSMbN6qSbC480wZZ",
	"hEITWnPk7YmezURImnXGgkMVa69FDcfQxLnf08hlwmeiasKUbTg/0WtmJgxLYBBmMDTMo3HAE44LC3zI",
	"PTqlpwGcg8tGOZB8eB5RdKZHq9Fm/B4KJKcbECgEgVQMPuS/nT8e/Pr7KPzmg69G16fJ8kHfXWfA/9AY",
	"FP0sXHav+ykOn5iYCVWJcQUUE0XYeHBrP0SOKThy1HiQhyzRdzZeHDKy3JOAp4AdKfrwYVXc42UkY3VH",
	"q7vTcA+070BUWN6M7sO9JdyjwKaNsamJKq+e84Q/OTt7dbZBlA1a9eC9UP5o6sJfhVD72yexdSScE4uP",
	"n9RA1PvJ6Yrsx+Ns18tehD3TPdJT5j1JQoeWeG+dMk7hIiGtAoalQFoLDthcVRUbAxNsLpymDSC+LkG3",
	"oiKtURqZ8mwM9F2CdVAIBPlOzxWWTGnaO4LiMqNZaea0Xq0zBYCkv42VAoEpTN9pnuxyodtXVkzoychu",
	"0cnh3Wa0sd1lUj/7tDKgaCiPb6hgEf8FLIJZyn0JQgZxiQLPfx68NaaaGDeFwY9bsiOseg6LuMN04aDC",
	"ir6t5rSK7tnj189IqMH5WOOTNE9PCLKxoIVVfMhP05M0p+QKLAOurP2WdpvgFLDPlqeAzIObqQLIC/MW",
	"CjVp98+UBw8uPDyTfMhftf6S7V7mYZ7faRfeTWxvm3WAjdM+MLCNg0mYKK1iXxKmZLOTrAwy+MeN8X1T",
	"QnGxijCOZlHf+tFFTS1oyl+N8NAq35HuI+FvYe62+jYgosB/89NPiCx2YH6tD11qVWyDHAi52FoqfHg+",
	"6qpVAzpV+FuxsR3LlGavnakBS2g8i0rTL93L1vLRsiFcYWYrofZTcrWn9SI/26hJh223GjeEjcZU2TX9",
	"ki4ss43tb28aSMKZqCq2MI3rRKAfMw0LK96JGhDI4PmuKWreOpgEgCdRqUgm1jrVQeObDSK6BpIDGRrd",
	"4xLZah/2FIOS0/VyXYLiYshvMr3Cmu0caXaq1ir6+Wg5WibcGr9PVRwIhKzd14RuIfRLFAd+7iJdNuDx",
	"ayMXH60+XUO2faQgMMt7ZMVmO76HFJQ+DfNqwYqQdsmMa3sP2VaIOPIoCuZhjqxP5x+dVQm/GhRGwhT0",
	"oK3NYGzkYtDWuUN6WDyy6/AYuVkB7jkcfhveH6JnHPEZ6Zkc8tWeZ//t6Z3w3TvljK5BI5sJp+LpkNpZ",
	"amTf6TEwuLLGg/xP6DXhylZGAh9OROVhL/CjoG9/Sve4CB2cV7WtgN+rRN5iMURibHP/0XEmr29W7kNR",
	"9+54b+jQIFbd542EpXH/0PULpGvX8Yq/E1lvUOBwlD/cxHYHt3j7tHFA7lM6Hva/zDZu+z5lT9k3rw7E",
	"2DThVuLQ7R8dAOL2rvT0Hju/+MnN9pfjhSlExaRyUCCTMIPK2LDG4xQqcuMqOi4h2mGWnTz8X5rTmX34",
	"/zzPeV9HXqhaDC5UZY5a81vmTvM8z9ZZ6F2Arm4SVhfpdMifCoS5WKzudvoehFWpnxUpMcqncKmEPEnn",
	"6kLVIJVIi8o0Mjg/vZX3MYRV8OEQyMAtYYT+yjg1VVRoPxfTKbjB+u7kYZrz5Z8BAAD//8uo7/KaGQAA",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
